var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import styled from 'styled-components';
import Highlight, { defaultProps } from 'prism-react-renderer';
import { LiveProvider, LiveEditor, LiveError, LivePreview as BaseLivePreview, } from 'react-live';
import { mdx } from '@mdx-js/react';
import getPrismTheme from './prism/prism-theme';
import { useColorMode } from './theme';
var Editor = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  padding: 15px 20px;\n  margin-bottom: 25px;\n  overflow: auto;\n  font-size: 14;\n  line-height: 1.45;\n  overflow-y: auto;\n  margin-top: 0;\n\n  > textarea:focus {\n    outline: none;\n  }\n"], ["\n  padding: 15px 20px;\n  margin-bottom: 25px;\n  overflow: auto;\n  font-size: 14;\n  line-height: 1.45;\n  overflow-y: auto;\n  margin-top: 0;\n\n  > textarea:focus {\n    outline: none;\n  }\n"])));
var LivePreview = styled(BaseLivePreview)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  padding: 15px 20px;\n  margin: 25px 0 0;\n  border: 1px rgba(0,0,0, 0.1) solid;\n  border-image: initial;\n  border-radius: 3px;\n\n  & + ", " {\n    margin-top: 10px;\n  }\n"], ["\n  padding: 15px 20px;\n  margin: 25px 0 0;\n  border: 1px rgba(0,0,0, 0.1) solid;\n  border-image: initial;\n  border-radius: 3px;\n\n  & + ", " {\n    margin-top: 10px;\n  }\n"])), Editor);
var globalModules = {
    react: 'React',
};
export function LiveConfig(_a) {
    var modules = _a.modules;
    Object.assign(globalModules, modules);
    return null;
}
function req(path) {
    var dep = globalModules[path];
    if (!dep) {
        throw new Error("Unable to resolve path to module '" + path + "'.");
    }
    return dep;
}
function importToRequire(code) {
    var _code = "/** @jsx mdx */\n" + code;
    _code = _code
        // { a as b } => { a: b }
        .replace(/([0-9a-z_$]+) as ([0-9a-z_$]+)/gi, '$1: $2')
        // import { a } from "a" => const { a } = require("b")
        .replace(/import {([^}]+)} from ([^\s;]+);?/g, 'const {$1} = require($2);')
        // import a from "a" => const a = require("a").default || require("a")
        .replace(/import ([\S]+) from ([^\s;]+);?/g, 'const $1 = require($2).default || require($2);')
        // import * as a from "a"
        .replace(/import \* as ([\S]+) from ([^\s;]+);?/g, 'const $1 = require($2);')
        // import a from "a" => const a = require("a").default || require("a")
        .replace(/import (.+),\s?{([^}]+)} from ([^\s;]+);?/g, [
        'const $1 = require($3).default || require($3);',
        'const {$2} = require($3);',
    ].join('\n'));
    return _code;
}
export function usePrismTheme() {
    var mode = useColorMode()[0];
    return getPrismTheme({ mode: mode });
}
export var Code = function (_a) {
    var children = _a.children, _b = _a.language, language = _b === void 0 ? 'jsx' : _b, live = _a.live, noInline = _a.noInline, render = _a.render;
    var code = children.trim();
    var prismTheme = usePrismTheme();
    if (live) {
        return (React.createElement(LiveProvider, { code: code, transformCode: importToRequire, scope: { mdx: mdx, require: req }, language: language, theme: prismTheme, noInline: noInline },
            React.createElement(LivePreview, null),
            React.createElement(Editor, { as: LiveEditor }),
            React.createElement(LiveError, null)));
    }
    if (render) {
        return (React.createElement("div", { style: { marginTop: '40px' } },
            React.createElement(LiveProvider, { code: code },
                React.createElement(LivePreview, null))));
    }
    return (React.createElement(Editor, null,
        React.createElement(Highlight, __assign({}, defaultProps, { code: code, language: language, theme: prismTheme }), function (_a) {
            var className = _a.className, style = _a.style, tokens = _a.tokens, getLineProps = _a.getLineProps, getTokenProps = _a.getTokenProps;
            return (React.createElement("pre", { className: className, style: style }, tokens.map(function (line, i) { return (React.createElement("div", __assign({}, getLineProps({ line: line, key: i })), line.map(function (token, key) { return (React.createElement("span", __assign({}, getTokenProps({ token: token, key: key })))); }))); })));
        })));
};
var templateObject_1, templateObject_2;
